import { DefaultStreamChatGenerics, UnknownType } from '../../types/types';
import React from 'react';
import { ItemProps } from 'react-virtuoso';
import { VirtuosoContext } from './VirtualizedMessageList';
export declare function calculateItemIndex(virtuosoIndex: number, numItemsPrepended: number): number;
export declare function calculateFirstItemIndex(numItemsPrepended: number): number;
type CommonVirtuosoComponentProps<StreamChatGenerics extends DefaultStreamChatGenerics = DefaultStreamChatGenerics> = {
    context?: VirtuosoContext<StreamChatGenerics>;
};
export declare const Item: <StreamChatGenerics extends DefaultStreamChatGenerics = DefaultStreamChatGenerics>({ context, ...props }: Pick<Pick<React.DetailedHTMLProps<React.HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "key" | keyof React.HTMLAttributes<HTMLDivElement>> & {
    ref?: ((instance: HTMLDivElement | null) => void) | React.RefObject<HTMLDivElement> | null | undefined;
}, "style" | "children"> & {
    'data-index': number;
    'data-item-index': number;
    'data-item-group-index'?: number | undefined;
    'data-known-size': number;
} & CommonVirtuosoComponentProps<StreamChatGenerics>) => JSX.Element;
export declare const Header: <StreamChatGenerics extends DefaultStreamChatGenerics = DefaultStreamChatGenerics>({ context, }: CommonVirtuosoComponentProps<StreamChatGenerics>) => JSX.Element | null;
export declare const EmptyPlaceholder: <StreamChatGenerics extends DefaultStreamChatGenerics = DefaultStreamChatGenerics>({ context, }: CommonVirtuosoComponentProps<StreamChatGenerics>) => JSX.Element;
export declare const Footer: <StreamChatGenerics extends DefaultStreamChatGenerics = DefaultStreamChatGenerics>() => JSX.Element | null;
export declare const messageRenderer: <StreamChatGenerics extends DefaultStreamChatGenerics = DefaultStreamChatGenerics>(virtuosoIndex: number, _data: UnknownType, virtuosoContext: VirtuosoContext<StreamChatGenerics>) => JSX.Element | null;
export {};
//# sourceMappingURL=VirtualizedMessageListComponents.d.ts.map