import type { ComponentType } from 'react';
import type { IconPropsV1 } from './FileIconSet/v1';
import type { IconPropsV2 } from './FileIconSet/v2';
import { GeneralType, SupportedMimeType } from './mimeTypes';
export type IconType = 'standard' | 'alt';
export type IconVersion = '1' | '2';
type IconProps = {
    '1': IconPropsV1;
    '2': IconPropsV2;
};
type IconMap = {
    [v in IconVersion]: {
        standard: Record<SupportedMimeType | GeneralType | 'fallback', ComponentType<IconProps[v]>>;
        alt?: Record<SupportedMimeType | GeneralType | 'fallback', ComponentType<IconProps[v]>>;
    };
};
export declare const iconMap: IconMap;
export {};
//# sourceMappingURL=iconMap.d.ts.map